unit HackmenuMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls;

type
  TMainForm = class(TForm)
    Panel1: TPanel;
    Memo1: TMemo;
    Timer1: TTimer;
    procedure Panel1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Panel1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    InMouseDown: Boolean;
    procedure HackWindowMenu(const WH: HWND);
  public
    { Public 錾 }
  end;

var
  MainForm: TMainForm;

implementation

uses
    Util;    

{$R *.dfm}

procedure TMainForm.FormCreate(Sender: TObject);
begin

    //  Lv`łȂ
    InMouseDown := false;

end;

var
    TargetHandle: HWND = INVALID_HANDLE_VALUE;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗Jn
procedure TMainForm.Panel1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if (Button = mbLeft) then
    begin
        InMouseDown := true;
        Screen.Cursor := CUR_SEEKER;
    end;
end;

//-----------------------------------------------------------------------------
//  łHłH
procedure TMainForm.Timer1Timer(Sender: TObject);
var
    WH: HWND;
begin
    if InMouseDown then
    begin
        //  ?
        if (GetAsyncKeyState(VK_ESCAPE) <> 0) then
        begin
            InMouseDown := false;
            Screen.Cursor := crDefault;
            Exit;
        end;
        //  }EẌʒũEBhEnh擾
        WH := WindowFromPoint(Mouse.CursorPos);
        //  
        FlashDesktopCanvas(WH, 100);
    end;
end;

//-----------------------------------------------------------------------------
//  ^[QbgEBhE擾̗I
//  http://yokohama.cool.ne.jp/chokuto/urawaza/setfont.html
procedure TMainForm.Panel1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    //  XpCłȂ΃XLbv
    if InMouseDown then
    begin
        //  tO|ăJ[\ɖ߂
        InMouseDown := false;
        Screen.Cursor := crDefault;
        //  }EX̃EBhEnho
        TargetHandle := WindowFromPoint(Mouse.CursorPos);
        //  ̂ڂ
        if (TargetHandle <> 0) then
        begin
            HackWindowMenu(GetMostTopLevelWindow(TargetHandle));
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  j[\J
procedure EnumMenu(const Menu: HMENU; const Level: integer; List: TStrings);
const
    MAX_LEN = 256;
var
    SubMenu: HMENU;
    i, ItemCount: integer;
    Buf: array[0..MAX_LEN] of Char;
    Mii: TMenuItemInfo;
begin
    //-------------------------------------------
    //  j[̃ACe擾
    ItemCount := GetMenuItemCount(Menu);
    //  ȂΏI
    if ItemCount < 0 then Exit;

    //-------------------------------------------
    //  ꂼɂȂ߂Ă
    for i := 0 to ItemCount - 1 do
    begin
        //----------------------------------
        //  j[LvV擾
        GetMenuString(Menu, i, Buf, MAX_LEN, MF_BYPOSITION);
        //  \
        List.Add(StringOfChar(' ', Level * 4) + Buf);

        //----------------------------------
        //  Tuj[nh擾
        SubMenu := GetSubMenu(Menu, i);

        //----------------------------------
        //  ċAI
        EnumMenu(SubMenu, Level + 1, List);

        //----------------------------------
        //  Ƃ
        FillChar(Mii, SizeOf(Mii), 0);
        Mii.cbSize := SizeOf(Mii);
        Mii.fMask := MIIM_TYPE;
        Mii.dwTypeData := Buf;
        Mii.cch := MAX_LEN;

        //----------------------------------
        //  o
        if GetMenuItemInfo(Menu, i, True, Mii) then
        begin
            //--------------------
            //  LvV
            Mii.dwTypeData := PChar(Buf + '܂');
            Mii.cch := SizeOf(Mii.dwTypeData);
            //--------------------
            //  Ԃ
            SetMenuItemInfo(Menu, i, True, Mii);
        end;
    end;
end;

//-----------------------------------------------------------------------------
//  j[𑀍삵Ă݂
procedure TMainForm.HackWindowMenu(const WH: HWND);
var
    Menu: HMENU;
begin
    //-------------------------------------------
    //  j[擾
    Menu := GetMenu(WH);
    //  ȂȂI
    if (Menu = INVALID_HANDLE_VALUE) then Exit;
    //  񋓂
    EnumMenu(Menu, 0, Memo1.Lines);

    //-------------------------------------------
    //  VXej[擾
    Menu := GetSystemMenu(WH, False);
    //  ȂȂI
    if (Menu = INVALID_HANDLE_VALUE) then Exit;
    //  񋓂
    EnumMenu(Menu, 0, Memo1.Lines);
end;

end.

